<template>
  <!-- Input container -->
  <div
    :class="{
      ...getElementCssClass('richSelectContainer'),
      ...getRootElementCSSClasses()
    }"
  >
    <!--
      @slot Label slot
    -->
    <slot name="label">
      <div
        v-if="label.length > 0"
        :class="getElementCssClass('richSelectLabel')"
      >
        <label :for="name">
          {{ label }}
          <span v-if="required"> *</span>
        </label>
      </div>
    </slot>

    <t-rich-select
      ref="t-rich-select"
      v-model="vModel"
      :hide-search-box="hideSearchBox"
      :variant="variant"
      :fixed-classes="tRichSelectStyle.fixedClasses"
      :classes="tRichSelectStyle.classes"
      :variants="tRichSelectStyle.variants"
      :placeholder="placeholder"
      :search-box-placeholder="searchBoxPlaceholder"
      :options="localOptions"
      :value-attribute="valueAttribute"
      :text-attribute="textAttribute"
      :clearable="clearable"
      :close-on-select="closeOnSelect"
      :multiple="multiple"
      :no-results-text="noResultsText"
      :disabled="disabled"
    >
      <template
        #label="tRichSelectLabelScope"
      >
        <slot
          v-bind="{...tRichSelectLabelScope}"
          name="selectedValue"
        >
          <!-- Support for multiple options OR unique option -->
          {{
            multiple
              ? `${tRichSelectLabelScope.options.length} ${$t('global.selected.plural_unisex')}`
              : tRichSelectLabelScope.option.text
          }}
        </slot>
      </template>

      <template
        slot="option"
        slot-scope="{ index, isHighlighted, isSelected, className, option, query }"
      >
        <!--
          @slot Slot for option content (see also: `TRichSelect` [vue-tailwind](https://www.vue-tailwind.com/docs/rich-select/#option-slot) component)
          @binding {number} index - The index of the option
          @binding {boolean} isHighlighted - If the option is highlighted
          @binding {boolean} isSelected - If the option is selected
          @binding {string} className - The optionContent class
          @binding {Object} option - An object with the 'text' and 'value' attribute together with a 'raw' attribute that contains the original option value before normalized
          @binding {string} query - The current search query
          @binding {Function} optionClickHandler - The option click handler
          @binding {boolean} isResetOption - Determines if option is the "reset" option
          @binding {boolean} isSelectAllOption - Determines if option is the "select all" option
        -->
        <slot
          name="optionContent"
          :index="index"
          :is-highlighted="isHighlighted"
          :is-selected="isSelected"
          :class-name="className"
          :option="option"
          :query="query"
          :option-click-handler="optionClickHandler"
          :is-reset-option="isResetOption(option)"
          :is-select-all-option="isSelectAllOption(option)"
        >
          <div
            :class="className"
            @click="optionClickHandler($event, option)"
          >
            <div
              class="flex items-center"
              :class="{
                'gap-3': (isResetOption(option) || isSelectAllOption(option))
              }"
            >
              <v-icon
                v-if="isSelectAllOption(option)"
                name="check-double"
              />
              <v-icon
                v-if="isResetOption(option)"
                name="empty"
              />
              <span>{{ option.text }}</span>
            </div>
            <v-icon
              v-if="isSelected"
              name="check"
            />
          </div>
        </slot>
      </template>

      <template #dropdownDown="slotScopeProps">
        <!--
          @slot Slot for select dropdownDown (see also: `TRichSelect` [vue-tailwind](https://www.vue-tailwind.com/docs/rich-select#dropdowndown-slot) component)
        -->
        <slot
          name="dropdownDown"
          :class-name="getElementCssClass('dropdownDown')"
          :v-bind="{ ...slotScopeProps }"
        />
      </template>
    </t-rich-select>

    <transition
      enter-active-class="_veryfast animated fadeIn"
      leave-active-class="_veryfast animated fadeOut"
    >
      <!--
        @slot Description slot
        @binding {string} className - The richSelectDescription class
      -->
      <slot
        v-if="description === true || description.length > 0"
        name="description"
        :class-name="getElementCssClass('richSelectDescription')"
      >
        <div :class="getElementCssClass('richSelectDescription')">
          <p>{{ description }}</p>
        </div>
      </slot>
    </transition>

    <transition
      enter-active-class="_veryfast animated fadeIn"
      leave-active-class="_veryfast animated fadeOut"
    >
      <!--
        @slot Error slot
      -->
      <slot
        v-if="error.length > 0"
        name="error"
      >
        <div :class="getElementCssClass('richSelectError')">
          <p>{{ error }}</p>
        </div>
      </slot>
    </transition>
  </div>
</template>

<script>
import { VariantableOptions } from '#mixins/variantable/'

import Select from '../select/Select'
import RichSelectStyle from './style'

/**
 * **RichSelect** component
 *
 * See also [vue-tailwind TRichSelect documentation](https://www.vue-tailwind.com/docs/rich-select/)
 */
export default {
  name: 'RichSelect',
  extends: Select,
  refs: [
    't-rich-select'
  ],
  props: {
    /**
     * Defines the position of the rich-select dropdown: can be "absolute" or "relative"
     */
    richSelectDropdownPosition: {
      type: String,
      default: 'absolute',
      validator: function (value) {
        // Si value est égale a "absolute" ou "relative"
        if (value === 'absolute' || value === 'relative') {
          return true
        }
        return false
      }
    },
    /**
     * Where the dropdown must be aligned ("right" or "left")
     */
    richSelectAlign: {
      type: String,
      default: 'left',
      validator: function (value) {
        // Si value est égale a "left" ou "right"
        if (value === 'left' || value === 'right') {
          return true
        }
        return false
      }
    },
    /**
     * vue-tailwind rich select queryFilter method overriding
     * see: https://github.com/alfonsobries/vue-tailwind/blob/master/src/components/TRichSelect.ts#L461
     */
    richSelectQueryFilter: {
      type: Function,
      default: undefined
    },
    /**
     * The rich-select size: can be "small", "default"
     */
    size: {
      type: String,
      default: 'default',
      validator: function (value) {
        if (value === 'small' || value === 'default') {
          return true
        }
        return false
      }
    },
    /**
     * value (to use v-model directive)
     *
     * See also how to [customize component v-model](https://vuejs.org/v2/guide/components-custom-events.html#Customizing-Component-v-model)
     */
    value: {
      type: [ Array, Object, String, Number ],
      default: ''
    },
    /**
     * iconName
     */
    iconName: {
      type: String,
      default: ''
    },
    /**
     * Close on select
     */
    closeOnSelect: {
      type: Boolean,
      default: true
    },
    /**
     * hideSearchBox
     */
    hideSearchBox: {
      type: Boolean,
      default: false
    },
    /**
     * clearable
     */
    clearable: {
      type: Boolean,
      default: false
    },
    /**
     * Multiple option
     */
    multiple: {
      type: Boolean,
      default: false
    },
    /**
     * No results text
     */
    noResultsText: {
      type: String,
      default: function () {
        return this.$filters.capitalize(this.$t('global.noResultsFound'))
      }
    },
    /**
     * Reset option (set the rich select v-model to "null" value or empty array if multiple)
     * See also ../Select.vue
     */
    resetOption: {
      type: [ Boolean, Object ],
      default: false
    },
    /**
     * Select all option: fill the v-model with all option values
     * ⚠ Works only in combination with "multiple" prop
     */
    selectAllOption: {
      type: [ Boolean, Object ],
      default: false
    }
  },
  computed: {
    /**
     * @returns {object} - The t-rich-select component
     */
    tRichSelectComponent () {
      return this.$refs['t-rich-select']
    },
    /**
     * ⚠ We have to return css classes as array because vue-tailwind RichSelect component
     * does not accept classes as object
     */
    tRichSelectStyle () {
      return new VariantableOptions(this.overriddenStyle, { cssClassesFormat: 'array' })
    },
    /**
     * Returns the processed options for rich-select
     * If `reset-option` or/and `select-all-option` props are set, add as first options array items
     */
    localOptions: function () {
      const itemsToConcat = []
      if (this.multiple && this.selectAllOption) {
        let _selectAllOption
        // selectAllOption can be boolean
        if (typeof this.selectAllOption === 'boolean') {
          _selectAllOption = this.getDefaultSelectAllOption()
        } else {
          _selectAllOption = this.selectAllOption
          // Ensure meta is set
          if (!_selectAllOption.meta) _selectAllOption.meta = {}
          if (!_selectAllOption.meta.selectAllOption) _selectAllOption.meta.selectAllOption = true
        }
        itemsToConcat.push(_selectAllOption)
      }
      if (this.resetOption) {
        let _resetOption
        // resetOption can be boolean
        if (typeof this.resetOption === 'boolean') {
          _resetOption = this.getDefaultResetOption()
        } else {
          _resetOption = this.resetOption
          // Ensure meta is set
          if (!_resetOption.meta) _resetOption.meta = {}
          if (!_resetOption.meta.resetOption) _resetOption.meta.resetOption = true
        }
        itemsToConcat.push(_resetOption)
      }
      return itemsToConcat.concat(this.options)
    }
  },
  watch: {
    /**
     * Watch richSelectDropdownPosition to apply corresponding styles
     */
    richSelectDropdownPosition: function (to, from) {
      this.applyDropdownPositionStyle()
    },
    /**
     * Watch size to apply corresponding styles
     */
    size: function (to, from) {
      this.applySizeStyle()
    },
    /**
     * Watch richSelectAlign to apply corresponding styles
     */
    richSelectAlign: function (to, from) {
      this.applyRichSelectPositionStyle()
    }
  },
  created () {
    this.applyDropdownPositionStyle()
    this.applySizeStyle()
    this.applyRichSelectPositionStyle()
  },
  mounted () {
    this.overrideQueryFilter()
  },
  methods: {
    /**
     * Set dropdown position based on richSelectDropdownPosition prop
     */
    applyDropdownPositionStyle () {
      this.style.fixedClasses.dropdown.absolute = (this.richSelectDropdownPosition === 'absolute')
      this.style.fixedClasses.dropdown.relative = (this.richSelectDropdownPosition === 'relative')
    },
    /**
     * Set rich select size based on size prop
     */
    applySizeStyle () {
      // For default
      this.style.fixedClasses.selectButton['py-2'] = (this.size === 'default')
      this.style.fixedClasses.selectButtonIcon['top-3.5'] = (this.size === 'default')
      // For small
      this.style.fixedClasses.selectButton['py-1'] = (this.size === 'small')
      this.style.fixedClasses.selectButtonIcon['top-2.5'] = (this.size === 'small')
    },
    /**
     * Set dropdown align based on richSelectAlign prop
     */
    applyRichSelectPositionStyle () {
      this.style.fixedClasses.dropdown['left-0'] = (this.richSelectAlign === 'left')
      this.style.fixedClasses.dropdown['right-0'] = (this.richSelectAlign === 'right')
    },
    /**
     * Set dropdown align based on richSelectAlign prop
     */
    overrideQueryFilter () {
      if (this.richSelectQueryFilter) {
        const tRichSelectComponent = this.tRichSelectComponent
        const richSelectQueryFilter = this.richSelectQueryFilter
        tRichSelectComponent.queryFilter = function (options) {
          return richSelectQueryFilter(this, options)
        }
      }
    },
    /**
     * Determines if option is the "reset" option
     * @param {object} option - The option object
     * @returns {boolean}
     */
    isResetOption (option) {
      return option.raw.meta && option.raw.meta.resetOption
    },
    /**
     * Determines if option is the "select all" option
     * @param {object} option - The option object
     * @returns {boolean}
     */
    isSelectAllOption (option) {
      return option.raw.meta && option.raw.meta.selectAllOption
    },
    /**
     * Handle click on option
     * @param {object} event - The event payload
     * @param {object} option - The option object
     * @returns {void}
     */
    optionClickHandler (event, option) {
      // If reset option, call specific handler
      if (this.isResetOption(option)) {
        this.resetOptionClickHandler(event, option)
      } else if (this.isSelectAllOption(option)) {
        // Else if select all option, call specific handler
        if (this.multiple) {
          this.selectAllOptionClickHandler(event, option)
        }
      }
    },
    /**
     * Default click handler on reset option, if provided
     * @param {object} event - The event payload
     * @param {object} option - The option payload
     * @returns {void}
     */
    resetOptionClickHandler (event, option) {
      /**
       * Emit event
       */
      this.$emit('reset-option-click', {
        event,
        option
      })
      // Reset v-model
      this.multiple
        ? this.vModel.splice(0, this.vModel.length)
        : this.vModel = null
    },
    /**
     * Default click handler on "select all"" option, if provided and multiple prop is true
     * @param {object} event - The event payload
     * @param {object} option - The option payload
     * @returns {void}
     */
    selectAllOptionClickHandler (event, option) {
      /**
       * Emit event
       */
      this.$emit('select-all-option-click', {
        event,
        option
      })
      // Set values
      this.vModel = this.options.map(opt => opt.value)
    },
    /**
     * The default "select all" option to pass in case of we want it
     * @returns {object} - The default "select all" option object
     */
    getDefaultSelectAllOption () {
      return {
        value: null, // null value. We use click handler to set v-model
        text: this.$filters.capitalize(this.$t('global.selectAll')),
        meta: {
          selectAllOption: true // add this meta property to tag option
        }
      }
    }
  },
  // Variantable option
  style: RichSelectStyle
}
</script>

<style lang="scss">
// ...
</style>

<docs lang="md">

### Variants

```jsx
let selectedOption;

<!--
  Theme 'light': alabaster
  Theme 'dark': haiti
-->
<p class="rsg--para-32">
  Variant: <b>{{ $app.ui.isTheme({
    'light': 'alabaster',
    'dark': 'haiti'
  }) }}</b>
</p>

<RichSelect
  v-model="selectedOption"
  name="option"
  :variant="$app.ui.isTheme({
    'light': 'alabaster',
    'dark': 'haiti'
  })"
  :options="[
    { value: 1, text: 'Option 1' },
    { value: 2, text: 'Option 2' },
    { value: 3, text: 'Option 3' }
  ]"
  label="Select an option"
  placeholder="Select"
  search-box-placeholder="Search"
  no-results-text="No results found"
  required
  class="mb-4"
/>

<!--
  Theme 'light': white-smoke
  Theme 'dark': mirage
-->
<p class="rsg--para-32">
  Variant: <b>{{ $app.ui.isTheme({
    'light': 'white-smoke',
    'dark': 'mirage'
  }) }}</b>
</p>

<RichSelect
  v-model="selectedOption"
  name="option"
  :variant="$app.ui.isTheme({
    'light': 'white-smoke',
    'dark': 'mirage'
  })"
  :options="[
    { value: 1, text: 'Option 1' },
    { value: 2, text: 'Option 2' },
    { value: 3, text: 'Option 3' }
  ]"
  label="Select an option"
  placeholder="Select"
  search-box-placeholder="Search"
  no-results-text="No results found"
  required
/>
```

### Multiple

```jsx
let selectedOptions;

<RichSelect
  v-model="selectedOptions"
  name="option"
  variant="primary"
  :options="[
    { value: 1, text: 'Option 1' },
    { value: 2, text: 'Option 2' },
    { value: 3, text: 'Option 3' }
  ]"
  label="Select an option"
  placeholder="Select"
  search-box-placeholder="Search"
  no-results-text="No results found"
  multiple
  fluid
  class="mb-4"
/>

</docs>
